edgeAges <- function( tree , age.taxon="Taxon" , taxon.age=0 ) {
	edge.dates<-matrix(nrow=nrow(tree$edge),ncol=ncol(tree$edge))

	next.node<-which(tree$tip.label==age.taxon)
		target<-which(tree$edge[,2]==next.node)
			target.length<-tree$edge.length[target]
				end.date<-taxon.age
					edge.dates[target,2]<-end.date
					edge.dates[target,1]<-end.date<-end.date+target.length
	next.node<-tree$edge[target,1]

	while(length(target)==1){
		target<-which(tree$edge[,2]==next.node)
			target.length<-tree$edge.length[target]
					edge.dates[target,2]<-end.date
					edge.dates[target,1]<-end.date<-end.date+target.length
		next.node<-tree$edge[target,1]
	}

	done<-as.integer(0)
	todo<-which(complete.cases(edge.dates))

			for(i in 1:length(todo)){
				target<-todo[i]
					next.node<-tree$edge[target,1]
						start.date<-edge.dates[todo[i],1]
							target<-which(tree$edge[,1]==next.node & !complete.cases(edge.dates))
								target.length<-tree$edge.length[target]
									edge.dates[target,1]<-start.date
									edge.dates[target,2]<-start.date-target.length
						nxt<-which(tree$edge[,1]==tree$edge[target,2] & !complete.cases(edge.dates))
							if(i==1) {todo.next<-nxt}
							if(i!=1) {todo.next<-c(todo.next,nxt)}
		}; 	done<-c(done,todo); todo<-todo.next

		while(sum(!complete.cases(edge.dates))>0) {
			for(i in 1:length(todo)){
				target<-todo[i]
					previous.node<-which(tree$edge[,2]==tree$edge[target,1])
						start.date<-edge.dates[previous.node,2]
							target.length<-tree$edge.length[target]
									edge.dates[target,1]<-start.date
									edge.dates[target,2]<-start.date-target.length
						nxt<-which(tree$edge[,1]==tree$edge[target,2] & !complete.cases(edge.dates))
							if(i==1) {todo.next<-nxt}
							if(i!=1) {todo.next<-c(todo.next,nxt)}
		}; 	done<-c(done,todo); todo<-todo.next
	}
edge.dates
}	